#include "textureclass.h"


TextureClass::TextureClass()
{
	m_texture = 0;
}


TextureClass::TextureClass(const TextureClass& other)
{
}


TextureClass::~TextureClass()
{
}


bool TextureClass::Initialize(ID3D11Device* device, WCHAR* filename)
{
	HRESULT result;
	D3DX11_IMAGE_LOAD_INFO loadInfo;
	ZeroMemory( &loadInfo, sizeof(D3DX11_IMAGE_LOAD_INFO) );
	loadInfo.BindFlags = D3D11_BIND_SHADER_RESOURCE;
	loadInfo.Format = DXGI_FORMAT_BC2_UNORM;
	loadInfo.MipLevels = D3DX11_DEFAULT; //ʱmipmaps㡣
	loadInfo.MipFilter = D3DX11_FILTER_LINEAR;

	// һļԴͼ.
	result = D3DX11CreateShaderResourceViewFromFile(device, filename, &loadInfo, NULL, &m_texture, NULL);
	if(FAILED(result))
	{
		return false;
	}

	//ЩǵԵ...
	ID3D11Texture2D* tex;
	m_texture->GetResource((ID3D11Resource**)&tex);
	D3D11_TEXTURE2D_DESC texdesc;
	tex->GetDesc(&texdesc);

	//ҲʹĴ봴shaderͼԴ,
	//ID3D11Texture2D * pTexture2D = NULL;
	//D3D11_SHADER_RESOURCE_VIEW_DESC srvDesc;
	//D3D11_TEXTURE2D_DESC desc;


	//D3DX11CreateTextureFromFile( device,filename, &loadInfo, NULL,(ID3D11Resource**)(&pTexture2D), NULL );

	//pTexture2D->GetDesc( &desc );

	//srvDesc.Format = desc.Format;
	//srvDesc.ViewDimension = D3D11_SRV_DIMENSION_TEXTURE2D;
	//srvDesc.Texture2D.MostDetailedMip = 0;
	//srvDesc.Texture2D.MipLevels = desc.MipLevels;

	//device->CreateShaderResourceView( pTexture2D, &srvDesc, &m_texture );

	return true;
}


void TextureClass::Shutdown()
{
	// ͷԴͼ
	if(m_texture)
	{
		m_texture->Release();
		m_texture = 0;
	}

	return;
}


ID3D11ShaderResourceView* TextureClass::GetTexture()
{
	return m_texture;
}