#pragma once

#include <d3d11.h>
#include <d3dx11tex.h>
#include <vector>
#include "common.h"
using namespace std;

class TexManagerClass
	{
	public:
		typedef std::vector<std::string> StringVector;
	public:
		TexManagerClass(void);
		TexManagerClass(const TexManagerClass&);
		~TexManagerClass(void);
		void Initialize(ID3D11Device*, WCHAR*);
		void Shutdown();

		ID3D11ShaderResourceView* createTex(ID3D11Device*,string );
		LPCWSTR TexManagerClass::stringToLPCWSTR(std::string orig);

	private:

		StringVector m_TextureNames;
		std::vector<ID3D11ShaderResourceView*> m_TextureRVs;

		ID3D11ShaderResourceView* m_RandomTexRV;
	};

