#pragma once

#include <d3dx10math.h>

class CameraClass
	{
	//֧ģ AIRCRAFT ڿռ˶,6ɶ
	// LANDOBJECT ĳЩضƶ
	public:
		enum CameraType { LANDOBJECT, AIRCRAFT };

	public:
		CameraClass(void);
		CameraClass(const CameraClass&);
		~CameraClass(void);

		void strafe(float units); // l
		void fly(float units);    // 
		void walk(float units);   // ǰ

		void pitch(float angle); // תviewϵright
		void yaw(float angle);   // תup
		void roll(float angle);  // תlook

		void getViewMatrix(D3DXMATRIX* V); 
		void setCameraType(CameraType cameraType); 
		void getPosition(D3DXVECTOR3* pos); 
		void setPosition(D3DXVECTOR3* pos); 

		void getRight(D3DXVECTOR3* right);
		void getUp(D3DXVECTOR3* up);
		void getLook(D3DXVECTOR3* look);
		void Reset();
	private:
		CameraType  _cameraType;
		D3DXVECTOR3 _right;
		D3DXVECTOR3 _up;
		D3DXVECTOR3 _look;
		D3DXVECTOR3 _pos;

	};

