#pragma once
#include <d3d11.h>
#include <d3dx10math.h>

class LightClass
	{
	public:
		LightClass(void);
		LightClass(const LightClass &);
		~LightClass(void);

		void SetLightPosition(float, float, float,float);
		void SetGlobalAmbient(float, float, float,float);
		void SetDirection(float, float, float);
		void SetLightColor(float, float, float,float);
		void SetLightAttenuation(float, float, float,float);
		void SetLightSpotLight(float, float, float,float);
		void SetShininess(float);

		D3DXVECTOR4 GetPosition();
		D3DXVECTOR4 GetGlobalAmbient();
		D3DXVECTOR3 GetDirection();
		D3DXVECTOR4 GetLightColor();
		D3DXVECTOR4 GetSpotLight();
		D3DXVECTOR4 GetLightAttenuation();
		float GetShininess();

	private:
		D3DXVECTOR4 m_position; //Դλ
		D3DXVECTOR4 m_globalAmbient; //ȫֻϵ
		D3DXVECTOR3 m_direction; //Դ,ƽй
		D3DXVECTOR4 m_lightColor; //Դɫ
		float m_shininess;  //߹ϵ
		D3DXVECTOR4 attenuation; //x, y,zֱ𱣴泣Լ˥ϵ
		D3DXVECTOR4 spotlight; //x,yֱ𱣴ڽǺֵ


	};

