#include "TexManagerClass.h"


TexManagerClass::TexManagerClass(void)
	{
	    m_RandomTexRV = 0;
	}

TexManagerClass::TexManagerClass(const TexManagerClass& others)
	{

	}

TexManagerClass::~TexManagerClass(void)
	{
	}

void TexManagerClass:: Initialize(ID3D11Device* device, WCHAR* filename)
	{
	return;
	}

void TexManagerClass::Shutdown()
	{
	for(int i = 0; i < m_TextureRVs.size(); ++i)
		{
		if(m_TextureRVs[i])
			{
			m_TextureRVs[i]->Release();
			m_TextureRVs[i] = 0;
			}

		}

	if(m_RandomTexRV)
		{
		m_RandomTexRV->Release();
		m_RandomTexRV = 0;
		}
	}


ID3D11ShaderResourceView* TexManagerClass::createTex(ID3D11Device* device,string filename)
	{

	// ԴѾڣ򷵻أ򴴽
	for(int i = 0; i < m_TextureRVs.size(); ++i)
		if(! m_TextureNames[i].compare(filename) )
			return m_TextureRVs[i];

	HRESULT result;
	D3DX11_IMAGE_LOAD_INFO loadInfo;
	ZeroMemory( &loadInfo, sizeof(D3DX11_IMAGE_LOAD_INFO) );
	loadInfo.BindFlags = D3D11_BIND_SHADER_RESOURCE;
	loadInfo.Format = DXGI_FORMAT_BC3_UNORM;
	loadInfo.MipLevels = D3DX11_DEFAULT; //ʱmipmaps
	loadInfo.MipFilter = D3DX11_FILTER_LINEAR;

	ID3D11ShaderResourceView* rv = 0;

	// һļԴͼ.
	result = D3DX11CreateShaderResourceViewFromFile(device, stringToLPCWSTR(filename), &loadInfo, NULL, &rv, NULL);
	if(FAILED(result))
		{
		HR(result);
		return false;
		}

	m_TextureNames.push_back(filename);
	m_TextureRVs.push_back(rv);

	return rv;
	}

LPCWSTR TexManagerClass::stringToLPCWSTR(std::string orig)
	{
	size_t origsize = orig.length() + 1;
	const size_t newsize = 100;
	size_t convertedChars = 0;
	wchar_t *wcstring = (wchar_t *)malloc(sizeof(wchar_t)*(orig.length()-1));
	mbstowcs_s(&convertedChars, wcstring, origsize, orig.c_str(), _TRUNCATE);

	return wcstring;
	}
